<?php
# hlavni skript
# startovni cislo: 39


# nacist tridy a funkce
require_once 'functions.php';
require_once 'classes.php';


?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
  <head>
    <meta http-equiv=Content-Type content="text/html; charset=windows-1250">
  </head>
  <body>
<?php
# zadal uzivatel mapu?
if (isset($_FILES['infile']))
{
    try {
        
        # nacist mapu
        $map = trim(file_get_contents($_FILES['infile']['tmp_name']));
        
        #################
        # validace mapy #
        #################

        $lines = explode("\r\n",$map);
        $rows = count($lines);
        # maximalni pocet radku: 255
        if ($rows > 255)
        {
            throw new Exception('Pli velk rozmry mapy.');
        }
        # obdelnikovy tvar mapy:
        $cols = strlen($lines[0]);
        if ($cols > 255)
        {
            throw new Exception('Pli velk rozmry mapy.');
        }
            
        foreach ($lines as $line)
        {
            if (strlen($line) != $cols)
            {
                throw new Exception('Mapa nem obdlnkov tvar.');
            }
        }
        
        # mapa obsahuje pouze pripustne znaky
        if (!preg_match('~^[XCS.:\r\n]*$~', $map))
        {
            throw new Exception('Soubor obsahuje nepovolen znaky.');
        }
        
        # mapa prosla, zobrazit ji
        
        ###################
        # generovani mapy #
        ###################
        
        # mapu namalujeme jako obrazek
        $image = imagecreate($cols, $rows);
        # alokovat barvy
        $col_x = imagecolorallocate($image, 0, 127, 0);     # trava         (znak X)
        $col_s = imagecolorallocate($image, 0, 0, 0);       # start         (znak S)
        $col_c = imagecolorallocate($image, 0, 0, 127);     # cil           (znak C)
        $col_r = imagecolorallocate($image, 192, 192, 192); # silnice       (znak .)
        $col_a = imagecolorallocate($image, 127, 127, 127); # horsi silnice (znak :)
        $col_p = imagecolorallocate($image, 255, 0, 0);     # zvolena cesta
        
        # mapa barev
        $color_map = array(
            'X' => $col_x,
            'S' => $col_s,
            'C' => $col_c,
            '.' => $col_r,
            ':' => $col_a
        );

        # $road: pole pro ulozeni silnice, indexovane X-ovou a Y-ovou souradnici dle zadani -
        #   - v tomto poli ma levy dolni roh souradnici [1;1], narozdil od normalniho
        #   oznaceni souradnic, kde levy HORNI roh ma souradnici [0;0] - nutno prepocitat;
        # prvek $road[$x][$y] obsahuje TRUE resp. FALSE, jestlize na souradnici
        #   [$x,$y] je resp. neni silnice
        $road = array();
        
        # $start: bod startu
        $start = null;
        # $finish: pole bodu, ktere tvori cil
        $finish = array();
        
        # namalovat mapu, pripravit si zaroven pole $road pro ulozeni silnice a pole $finish
        for ($y=0; $y<count($lines); $y++)
        {
            for ($x=0; $x<strlen($lines[$x]); $x++)
            {
                # znak na pozici [$x,$y]
                $char = $lines[$y][$x];
                # dle zadani jsou souradnice:
                $new_x = $x+1;
                $new_y = $rows-$y;
                
                # zanest do $road
                $road[$new_x][$new_y] = in_array($char, array('.',':','S','C'));
                
                # zapsat start
                if ($char=='S')
                {
                    if (!empty($start))
                    {
                        # zadano vice startu - chyba mapy
                        throw new Exception('Tra m vce start.');
                    }
                    $start = new Point($new_x, $new_y);
                }
                
                # zanest do finish
                if ($char=='C')
                {
                    $finish[] = new Point($new_x, $new_y);
                }
                
                # namalovat bod na mapu
                imagesetpixel($image, $x, $y, $color_map[$char]);
            }
        }
        
        # ma mapa start?
        if (is_null($start))
        {
            throw new Exception('Tra nem start.');
        }
        
        
        ####################################
        # vlastni algoritmus hledani cesty #
        ####################################
        
        /* popis navrzeneho algoritmu:
        Uvazime usecku spojujici start a cil. Jestlize je cela tato spojnice pouzitelnou
        trati, muzeme jet primo ze startu do cile po teto spojnici. Jestlize se na spojnici
        vyskutuji useky, kde je trat prerusena travou, urcime stred prvniho takoveho travnateho
        useku. Timto stredem vedeme kolmici k uvazovane spojnici. Kde tato kolmice protne
        nejblizsi usek pouzitelne trati, urcime bod A. Nyni hledame cestu ze startu do A
        a z A do cile. To vyresime rekurzivne, nebot to je jiz poduloha puvodni ulohy.
        */
        
        try
        {
            # zaciname na startu
            $start_point = $start;
            # koncime v cili - priblizne stred ciloveho obdelniku
            $end_point = mid_point($finish[0], $finish[count($finish)-1]);
    
            $parts_to_examine = array(
                array($start_point, $end_point)
            );
            $path = array();
            find_path($parts_to_examine, $path, $road);
            print_r($path);
        }
        catch (PathException $e)
        {
?>
            <p><strong><?php echo $e->getMessage(); ?></strong></p>
<?php
        }
        
        
        ##########
        # vystup #
        ##########
        
        # konecny vystup obrazku
        # zvetsit na dvojnasobne rozmery
        $image_2 = imagecreate($cols*2, $rows*2);
        imagecopyresized($image_2, $image, 0, 0, 0, 0, $cols*2, $rows*2, $cols, $rows);
        # ulozit vysledny obrazek
        imagegif($image_2, 'map.gif');
        
?>
        <h1>Naten mapa:</h1>
        <img src="map.gif">
<?php
    }
    catch (Exception $e)
    {
?>
        <p><strong><?php echo $e->getMessage(); ?></strong></p>
<?php
    }
        
        
}
?>
    <form action="auto.php" method="post" enctype="multipart/form-data">
      <fieldset>
        <legend>Zadn vstupu</legend>
        <label for="infile">Vstupn soubor s mapou:</label>
        <input type="file" name="infile" id="infile">
        <input type="submit" name="ok" value="Nast">
<!--
        <br><br>
        Vsledn dc soubor:<br>
        <input type="radio" name="outfile_type" id="outfile_type_d" value="direct" checked>
        <label for="outfile_type_d">pmo na vstup</label>
        <br>
        <input type="radio" name="outfile_type" id="outfile_type_f" value="file">
        <label for="outfile_type_f">do souboru:</label>
        <input type="text" name="outfile_name">
        (zadejte cestu)
-->
      </fieldset>
    </form>
  </body>
</html>
